User:Opensource Obscure/Compiling

From Second Life Wiki
< User:Opensource Obscure
Revision as of 15:16, 20 August 2011 by Opensource Obscure (Talk | contribs)

(diff) ← Older revision | Latest revision (diff) | Newer revision → (diff)
Jump to: navigation, search

User page - JIRA - Interests - Groups - LSL - Places - Stores - Translations - other pages



This an incomplete, out-of-date, still possibly useful repository of instructions to build a Linux viewer from sources.. You're welcome to read this page, and you may even find it useful, but it's mostly a personal scrapbook page.

Overview

RESULTS Viewer dev Snowstorm Linux Merov Features Mesh dev
DOWNLOAD Linux Viewer dev Linux Snowstorm Linux Merov Features Mesh Linux Mesh dev

Dipendenze

Ho disinstallato ccache e gcc-4.1.

sudo apt-get install cmake flex bison build-essential python libx11-dev zlib1g-dev libssl-dev mesa-common-dev libglu1-mesa-dev libc6-dev libstdc++6 libxrender-dev
sudo apt-get install libogg-dev libpng12-dev libdbus-glib-1-dev libgtk2.0-dev
sudo apt-get install mercurial python-pip
sudo pip install autobuild

Compilare i sorgenti

hg clone https://bitbucket.org/merov_linden/viewer-autobuild2010
cd viewer-autobuild2010
autobuild build -c RelWithDebInfoOS

Nota su hg clone

  • once you have a local clone, you should keep that repository, and next time, just use pull. this will just download the latest changes, ie. from the last time you cloned or pulled. and then issue an update: basically, you would issue this command:
hg pull -u
  • to overcome the initial problem of cloning over a slow network, you could clone parts of the repository as well. For instance, if the remote repository consists of 1000 changesets, you can use this command:
hg clone URL . -r 250
  • with the dot, you say: clone into the current directory. Without it, mercurial might create a directory for your clone
  • this will clone 250 changesets, then you can pull in batches as well: hg pull -r 500, hg pull -r 750 and then hg pull -u

this might overcome the timeout problem, otherwise you're just going to have to retry

  • once you have the local clone, a pull should take far less time, and if a pull times out, just retry the pull, it will still only have to download new changesets, not the whole repository

Build Download Permalinks

Informazioni prese da Automated_Build_System.

gcc / Ubuntu

informazioni probabilmente obsolete

Il gcc che c'è di default nelle versioni recenti di Ubuntu non va bene, si deve usare invece la versione 4.1. Ecco come mantenere entrambe le versioni di gcc installate nel sistema, scegliendo con update-alternatives --config gcc quale versione usare effettivamente quando viene chiamato gcc:

sudo update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-4.1 41 --slave /usr/bin/g++ g++ /usr/bin/g++-4.1 --slave /usr/bin/gcov gcov /usr/bin/gcov-4.1
sudo update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-4.4 44 --slave /usr/bin/g++ g++ /usr/bin/g++-4.4 --slave /usr/bin/gcov gcov /usr/bin/gcov-4.4
sudo update-alternatives --config gcc

a questo punto, selezionare gcc-4.1:

------------------------------------------------------------
* 0            /usr/bin/gcc-4.4   44        modalità automatica
  1            /usr/bin/gcc-4.1   41        modalità manuale
  2            /usr/bin/gcc-4.4   44        modalità manuale
Premere Invio per mantenere il valore predefinito[*] o digitare il numero della selezione:1
update-alternatives: viene usato /usr/bin/gcc-4.1 per fornire /usr/bin/gcc (gcc) in modalità manuale.

D'ora in poi il sistema userà la versione 4.1 di gcc. Ripetere l'ultimo passo se c'è bisogno di usare la versione più recente di gcc.

Applicare una patch

Esempio:

user@box:~/snowglobe/linden$ patch -p0 < SNOW-247_translation_breaks_chat_bubbles.diff 

SpaceNavigator

Nota: Non funziona più con i kernel recenti. Con Kirstens funziona.

Va inizialmente creato (una tantum) il file /etc/udev/rules.d/41-spacenavigator.rules con questo contenuto (forse basta la terza riga):

KERNEL=="event[0-9]*", SYSFS{idVendor}=="046d", SYSFS{idProduct}=="c603", SYMLINK+="input/spacemouse", GROUP="plugdev"
KERNEL=="event[0-9]*", SYSFS{idVendor}=="046d", SYSFS{idProduct}=="c623", SYMLINK+="input/spacetraveler", GROUP="plugdev"
KERNEL=="event[0-9]*", SYSFS{idVendor}=="046d", SYSFS{idProduct}=="c626", SYMLINK+="input/spacenavigator", GROUP="plugdev"

Old stuff

Prob. obsolete: User:Opensource_Obscure/Compiling/FMOD

Come trovare le dipendenze richieste

(vedi qui) - ESEMPIO con omvviewer:

omvviewer/indra/build/newview>ldd ./omvviewer